﻿/* Copyright 2022, Kasyan Servetsky
March 31, 2022
Written by Kasyan Servetsky
http://www.kasyan.ho.ua
e-mail: askoldich@yahoo.com */
//======================================================================================
#targetengine "Kasyan"
Reset();
var scriptName = "Find Text in Location - 1.16",
debugMode = false,
doc, set, w,  tmpFileName,
btnFind, btnChange, btnChangeAll, btnChangeFind,
f = 0,
textArr = [], 
foundAll = false,
warning = false,
look = false, // look behind / ahead. /K
hasSpaceAtLineEnd = null,
storyProcessed = null,
tmpFindWhat = null,
counter = 1;

PreCheck();
//===================================== FUNCTIONS ======================================
function CheckLocation(txt) {
	try {
		var txtContents = txt.contents,
		result = false,
		line = txt.lines[0],
		lineContNoMarkers = line.contents.replace(/\uFEFF/g, "").replace(/\uFFFC/g, ""), // 65279 = FEFF hyperlink anchor, index marker
		lineContNoSpaces = lineContNoMarkers.replace(/\r+$/, "").replace(/\n+$/, "").replace(/ +$/, ""),
		regExp = null,
		match = null,
		regExpEnd = null,
		matchEnd = null,		
		lastChar,
		firstChar = line.characters[0];
		
		txtContents = EscapeSpecialChars(txtContents);

		if (hasSpaceAtLineEnd) {
			lastChar = line.characters[-1];
		}
		else {
			lastChar = line.characters[line.characters.length - (lineContNoMarkers.length - lineContNoSpaces.length) - 1];
		}

		if (lastChar.contents == "\r") {
			if (debugMode) $.writeln("lastChar.contents == \r");
			lastChar = lastChar.parentStory.characters[lastChar.index - 1];
		}

		if (set.ddlLocation == 0) { // Beginning
			if (look) {
				if (lineContNoSpaces.indexOf(tmpFindWhat) == 0) {
					result = true;
				}
			}
			else if (txt.contents.constructor.name == "Enumerator") {
				if (debugMode) $.writeln("Enumerator");
				if (txt == firstChar) {
					result = true;
				}
			}
			else {
				regExp = eval("/^" + txtContents + "/");

				if (regExp != null) match = lineContNoSpaces.match(regExp);

				if (match != null && firstChar.index == txt.characters[0].index) {
					result = true;
				}
			}
		}
		else if (set.ddlLocation == 1) { // End
			if (look) {
				result = CheckPosition(txt, true);
				if (!result) {
					if (lineContNoSpaces.indexOf(tmpFindWhat) == lineContNoSpaces.length - tmpFindWhat.length) {
						result = true;
					}
				}
			}
			else if (txt.contents.constructor.name == "Enumerator") {
				if (debugMode) $.writeln("Enumerator");
				if (txt == lastChar) {
					result = true;
				}
			}
			else {
				if (debugMode) $.writeln("Not Enumerator - " + txt.contents.constructor.name);
				// It only affects the behavior of ^ and $. In the multiline mode they match not only at the beginning and the end of the string, but also at start/end of line.
				regExp = eval("/" + txtContents + "$/m");

				if (regExp != null) match = (hasSpaceAtLineEnd) ? lineContNoMarkers.match(regExp) : lineContNoSpaces.match(regExp);

				if (match != null) {
					if (hasSpaceAtLineEnd) {
						var regExpEnd = eval("/" + txtContents + "$/m");
						var matchEnd = lineContNoMarkers.match(regExpEnd);

						if (matchEnd != null && lastChar.index == txt.characters[-1].index) {
							result = true;
						}
					}
					else if (!hasSpaceAtLineEnd && lastChar.index == txt.characters[-1].index) {
						result = true;
					}
				} // match != null
			}
		}
		else if (set.ddlLocation == 2) { // Both
			if (look) {
				if (lineContNoSpaces.indexOf(tmpFindWhat) == 0) { // Beginning
					result = true;
				}
				else { // End
					result = CheckPosition(txt, true);
					if (!result) {
						if (lineContNoSpaces.indexOf(tmpFindWhat) == lineContNoSpaces.length - tmpFindWhat.length) {
							result = true;
						}
					}
				}
			}
			else if (txt.contents.constructor.name == "Enumerator") {
				if (debugMode) $.writeln("Enumerator");
				if (txt == firstChar) {
					result = true;
				}
				else if (txt == lastChar) {
					result = true;
				}
			}
			else {
				regExp = eval("/^" + txtContents + "/");
 
				if (regExp != null) match = lineContNoSpaces.match(regExp);

				if (match != null && firstChar.index == txt.characters[0].index) {
					result = true;
				}
				else { // not found at the beginning, then try at the end
					regExp = eval("/" + txtContents + "$/m");
				
					if (regExp != null) match = (hasSpaceAtLineEnd) ? lineContNoMarkers.match(regExp) : lineContNoSpaces.match(regExp);

					if (match != null) {
						if (hasSpaceAtLineEnd) {
							var regExpEnd = eval("/" + txtContents + "$/m");
							var matchEnd = lineContNoMarkers.match(regExpEnd);
				
							if (matchEnd != null && lastChar.index == txt.characters[-1].index) {
								result = true;
							}
						}
						else if (!hasSpaceAtLineEnd && lastChar.index == txt.characters[-1].index) {
							result = true;
						}
					} // match != null
				}
			}
		} // Both

		return result;
	}
	catch(err) {
		alert(err.message + ", line: " + err.line, scriptName, true);
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function CheckPosition(txt, end) {
	try {
		var edge;
		var result = false;
		var txtCharLength = txt.characters.length;
		var txtFirstCharIdx = txt.characters[0].index;
		var txtLastCharIdx = txt.characters[txt.characters.length - 1].index;

		var line = txt.lines[0];
		var lineCharLength = line.characters.length; 
		var lineFirstCharIdx = line.characters[0].index;
		var lineLastCharIdx = line.characters[line.characters.length - 1].index;
		
		if (end) {
			edge = line.characters.itemByRange(lineCharLength - txtCharLength, lineCharLength - 1);
		}
		else {
			edge = line.characters.itemByRange(0, txtCharLength - 1);
		}
		
		result = (edge == txt);

		return result;
	}
	catch(err) {
		alert(err.message + ", line: " + err.line, scriptName, true);
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function EscapeSpecialChars(txt) {
	if (txt.constructor.name == "String") {
		txt = txt.replace(/\uFEFF/g, "").replace(/\uFFFC/g, ""); // 65532 = FFFC anchored object
		txt = txt.replace(/\\/g, "\\\\");
		txt = txt.replace(/\//g, "\\/");		
		txt = txt.replace(/\./g, "\\.");	
		txt = txt.replace(/\(/g, "\\(");
		txt = txt.replace(/\[/g, "\\[");
		txt = txt.replace(/\^/g, "\\^");
		txt = txt.replace(/\$/g, "\\$");
		txt = txt.replace(/\?/g, "\\?");
		txt = txt.replace(/\*/g, "\\*");
		txt = txt.replace(/\+/g, "\\+");
		txt = txt.replace(/\{/g, "\\{");
	}

	return txt;
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function IsSpecialCharacter(character) {
	var result = false,
	item,
	str = "()*[]\^$.|?+{}",
	list = [];

	for (var j = 0; j < str.length; j++) {
		list.push(str[j]);
	}
	
	for (var i = 0; i < list.length; i++) {
		item = list[i];
		if (character == item) {
			result = true;
			break;
		}
	}
	
	return result;
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function HasSpaceAtLineEnd() { // check if findWhat has a space optionally followed by repeat
	var result = false,
	item, regex, match,
	findWhat = app.findGrepPreferences.findWhat,
	list = ["\\s", "\\\\t", "\\h", "~m", "~>", "~f", "~\\|", "~S", "~s", "~m", "~<", "~\\/", "~\\.", "~3", "~4", "~%"],
	repeat = ["\\?", "\\+", "\\*", "\\?\\?", "\\*\\?", "\\+\\?"];

	for (var i = 0; (i < list.length && !result); i++) {
		item = list[i];
		// if (debugMode) $.writeln("i = " + i + ", item = " + item);		
		regex = new RegExp(item + "$");
		match = findWhat.match(regex);
		
		if (match != null) {
			result = true;
		}
		else {
			for (var j = 0; j < repeat.length; j++) {
				regex = item + repeat[j] + "$";
				// if (debugMode) $.writeln("j = " + j + ", repeat = " + repeat[j]);
				
				if (findWhat.match(regex) != null) {
					result = true;
					break;
				}
			}
		}
	} // end for
	
	return result;
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function ChangeAll() {
	var item,
	count = 0;
	
	for (var i = 0; i < textArr.length; i++) {
		item = textArr[i];
		count++;
		ProcessText(item);
	}

	btnFind.text = "Find";
	btnChange.enabled = btnChangeAll.enabled = btnChangeFind.enabled = false;
	alert("Search is completed. " + count + " replacement" + ((count == 1) ? " was" : "s were") + " made.", scriptName);
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function ChangeItem() {
	ProcessText(app.selection[0]);
	btnChange.enabled = false;
	if (f == textArr.length) {
		Reset();
		alert("Search is completed.", scriptName);
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function ProcessText(txt) {
	try {
		var savedFindWhat;
		counter++;

		if (look) {
			savedFindWhat = app.findGrepPreferences.findWhat;
			app.findGrepPreferences.findWhat = txt.contents;
		}
		
		var changed = txt.changeGrep();
		
		if (look) {
			app.findGrepPreferences.findWhat = savedFindWhat;
		}
	}
	catch(err) {
		alert(err.message + ", line: " + err.line, scriptName, true);
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function IsLook() {
	var result = false,
	f = app.findGrepPreferences.findWhat;

	if (f.match(/\(\?<=/) != null) {
		tmpFindWhat = f.replace(/\(\?<=/g, "").replace(/\)/g, "");
	}
	else if (f.match(/\(\?=/) != null) {
		tmpFindWhat = f.replace(/\(\?=/g, "").replace(/\)/g, "");
	}
	else if (f.match(/\\K/) != null) {
		tmpFindWhat = f.replace(/\\K/g, "");
	}

	if (f.match(/\(\?<=/) != null ||
		f.match(/\(\?=/) != null ||
		f.match(/\\K/) != null
	) {
		result = true;
	}

	return result; 
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function FindAll() {
	try {
		if (set.cbStory) {
			CheckStory();
			if (storyProcessed == null) return;
		}

		look = IsLook();
		
		var item, checkLocation, found;
		
		 if (set.cbStory && storyProcessed != null) {
			found = storyProcessed.findGrep(false);
		}
		else {
			found = app.documents[0].findGrep(false);
		}

		if (hasSpaceAtLineEnd === null) {
			hasSpaceAtLineEnd = HasSpaceAtLineEnd();
		}

		if (found.length == 0) {
			alert("Cannot find match.", scriptName);
			btnFind.text = "Find";
		}
		else {
			for (var i = 0; i < found.length; i++) {
				item = found[i];
				checkLocation = CheckLocation(item);

				if (checkLocation) {
					textArr.push(item);
					// if (debugMode) $.writeln("pushed " + item.contents);
				}
				// if (debugMode) $.writeln("i = " + i + " | " + item.contents  + " | " + checkLocation  + " | " + item.lines[0].contents);		
			}

			btnFind.text = "Find Next";
			foundAll = true;
			btnChange.enabled = btnChangeAll.enabled = btnChangeFind.enabled = true;
		}
	}
	catch(err) {
		alert(err.message + ", line: " + err.line, scriptName, true);
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function CheckStory() {
	// check if text is selected
	if (app.selection.length == 0 || app.selection.length > 1) {
		alert("One text frame or some text should be selected, or the cursor should be inserted into the text.", scriptName, true);
	}
	else {
		var sel = app.selection[0];
			
		if (sel.constructor.name == "TextFrame") { // a text frame is selected
			storyProcessed = sel.texts[0].parentStory;
		}
		else if (sel.hasOwnProperty("baseline")) { // some text is selected or the cursor is placed in the text
			storyProcessed = sel.parentStory;
		}
		else {
			alert("One text frame or some text should be selected, or the cursor should be inserted into the text.", scriptName, true);
		}

		if (storyProcessed == undefined || !storyProcessed.isValid) alert("Can't find the story.", scriptName, true);
		
		if (storyProcessed.contents == "") { // story is empty
			storyProcessed = null;
			alert("The selection contains no text.", scriptName, true);
		}
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function IterateFindsChange() {
	if (f == textArr.length) {
		Reset();
		alert("Search is completed.", scriptName);
	}
	else {
		IterateFinds();
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function IterateFinds() {
	var item,
	story = null;
	
	if (f == textArr.length) {
		Reset();
		alert("Search is completed.", scriptName);
		return;
	}

	for ( ; f < textArr.length; ) {
		item = textArr[f];

		try { 
			story = item.parentStory;
		}
		catch(err) {
			if (debugMode) $.writeln(err.message + ", line: " + err.line);
		}

		if (story != null && story.overflows && !warning) {
			alert("The text in this story is partially overset. The changes in the overset text may lead to unexpected results.", scriptName);
			warning = true;
		}

		try { // quick & dirty solution so far
			app.select(item, SelectionOptions.replaceWith);
			app.activeWindow.zoom = ZoomOptions.fitPage;
			app.activeWindow.zoomPercentage = set.zoom;
		}
		catch(err) {
			app.activeWindow.zoomPercentage = 100;
			if (debugMode) $.writeln(err.message + ", line: " + err.line);
		}

		f++;
		// if (debugMode) $.writeln("f = " + f + " out of " + textArr.length);
		btnChange.enabled = btnChangeFind.enabled = true;
		
		return;
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function CreateDialog() {
	GetDialogSettings();
	w = new Window("palette", scriptName.replace(/\-\s\d+\.\d+$/, "")); // global
	if (set.dlgLocation != null) {
		w.location = set.dlgLocation;
	}
	w.onClose = function() {
		try {
			set.dlgLocation = String(w.location);
			set.ddlLocation = ddlLocation.selection.index;
			set.zoom = etZoom.text;
			set.cbStory = cbStory.value;
			app.insertLabel("Kas_" + scriptName, set.toSource());
		}
		catch(err) {
			alert(err.message + ", line: " + err.line, scriptName, true);
		}
	}
	
	var pnlLocation = w.add("panel", undefined, "");
	pnlLocation.orientation = "column";
	pnlLocation.alignment = "fill";
	pnlLocation.alignChildren = "right";
	
	var stLocation = pnlLocation.add("statictext", undefined, "Location on the line:");
	var ddlLocation = pnlLocation.add("dropdownlist", undefined, ["Beginning", "End", "Both"]);
	ddlLocation.selection = set.ddlLocation;
	ddlLocation.alignment = "fill";
	ddlLocation.onChange = function() {
		set.ddlLocation = this.selection.index;
		Reset();
	}

	var grZoom = pnlLocation.add("group");
	grZoom.orientation = "row";
	
	var iconBinReset = "\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x14\x00\x00\x00\x14\b\x06\x00\x00\x00\u008D\u0089\x1D\r\x00\x00\x00\tpHYs\x00\x00\x0B\x13\x00\x00\x0B\x13\x01\x00\u009A\u009C\x18\x00\x00\x06\u00BEiTXtXML:com.adobe.xmp\x00\x00\x00\x00\x00<?xpacket begin=\"\u00EF\u00BB\u00BF\" id=\"W5M0MpCehiHzreSzNTczkc9d\"?> <x:xmpmeta xmlns:x=\"adobe:ns:meta/\" x:xmptk=\"Adobe XMP Core 7.1-c000 79.a8731b9, 2021/09/09-00:37:38        \"> <rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"> <rdf:Description rdf:about=\"\" xmlns:xmp=\"http://ns.adobe.com/xap/1.0/\" xmlns:dc=\"http://purl.org/dc/elements/1.1/\" xmlns:photoshop=\"http://ns.adobe.com/photoshop/1.0/\" xmlns:xmpMM=\"http://ns.adobe.com/xap/1.0/mm/\" xmlns:stEvt=\"http://ns.adobe.com/xap/1.0/sType/ResourceEvent#\" xmp:CreatorTool=\"Adobe Photoshop 22.5 (Windows)\" xmp:CreateDate=\"2022-02-17T08:23:36+02:00\" xmp:ModifyDate=\"2022-02-17T10:09:30+02:00\" xmp:MetadataDate=\"2022-02-17T10:09:30+02:00\" dc:format=\"image/png\" photoshop:ColorMode=\"3\" photoshop:ICCProfile=\"Adobe RGB (1998)\" xmpMM:InstanceID=\"xmp.iid:544ee920-4cda-6646-baa6-7edb9c0e5021\" xmpMM:DocumentID=\"adobe:docid:photoshop:c8774ef7-74f4-bc4f-a7c4-a4a0856a35a5\" xmpMM:OriginalDocumentID=\"xmp.did:1f6f5141-8461-414e-b95e-279858268f8e\"> <xmpMM:History> <rdf:Seq> <rdf:li stEvt:action=\"created\" stEvt:instanceID=\"xmp.iid:1f6f5141-8461-414e-b95e-279858268f8e\" stEvt:when=\"2022-02-17T08:23:36+02:00\" stEvt:softwareAgent=\"Adobe Photoshop 22.5 (Windows)\"/> <rdf:li stEvt:action=\"saved\" stEvt:instanceID=\"xmp.iid:d5ee5de3-dcd2-5944-9c5f-ceb7280a29eb\" stEvt:when=\"2022-02-17T10:08:12+02:00\" stEvt:softwareAgent=\"Adobe Photoshop 22.5 (Windows)\" stEvt:changed=\"/\"/> <rdf:li stEvt:action=\"saved\" stEvt:instanceID=\"xmp.iid:544ee920-4cda-6646-baa6-7edb9c0e5021\" stEvt:when=\"2022-02-17T10:09:30+02:00\" stEvt:softwareAgent=\"Adobe Photoshop 22.5 (Windows)\" stEvt:changed=\"/\"/> </rdf:Seq> </xmpMM:History> </rdf:Description> </rdf:RDF> </x:xmpmeta> <?xpacket end=\"r\"?>\u00EF\u009A\u0097B\x00\x00\x01.IDAT8\x11\u00AD\u00C1?nR\x01\x00\x07\u00E0/\u00C2\u00F3\x06N\f/u\x11\u00E8\t:9y\x01;iIpw\u00F0\x06\u00AE\u00A6\u00A6\x7F\u0088\u009B^\u00C0\u008Dn\x1A=\u00C2s\x11\u00B9\x05\x18:\u00B4I\x13\u0097\u009F\u008FHb\u00D3?\x01J\u00BF\u00CF-\x1E\u00E2\x15Np\u008E 8\u00C7\t\u00FA(\u00FC\u00F7\foQ\u00B8A\x0FS\x04\u00C1\x04\x15*L\x11\x04\x13\u00EC\u00F9\u00E73\u0082\u00B6+\x0E\x11\x04\u00EF\u00D0q]\x17\u00FB\b\u0082\u00D7\u00F8\u0088`\u00DB%\x1F\x10\u00FC\u00C4\x13\u00CB51D\u00F0\x07A\u00C7\u00C2.\u0082_hX\u00EE)>\u00E1\x0B\u0082 \u00D8Vk\u00E0\x14A\u00CBj\u00DE \b\u0082 \u00E8\u00A8\u00F5\x10\x1CZO\u0089\x12%J\u0094(\u00D4\u00BE#\u00D8rO.0s\u008F\u0082\u00CA\u0086\u0092Hb.\u00F8aCI$1w\u0081\u0099\u00CD=\u00C2\u008E\u00DA7\x04[\u00EE\u00EE1\u0082\u00AFj=\x04G\u00EE\u00EE\x18\u00C1K\u00B5\x06N\x11\u00B4\u00AC\u00AF\u0085`\u0086\x07\x16v\x11\u008C\u00D1\u00B4\u00BA&\u00C6\b\u009E\u00BBb\u0080`\u0084\u00B6\u00E5\u00DA\x18!\x18\u00B8\u00C5\x01\u0082`\x1F]\u00D7u\u00F1\x1EAp`\u0089=L\x10\x04ST\u00A8\u00F0\x1BA0\u00C1\x0B+*\u00D0\u00C7\x10g\b\u00823\f\u00D1G\u00E1\x06\x7F\x01\u00F8-r\u00F4G\x7F\x05t\x00\x00\x00\x00IEND\u00AEB`\u0082";
	var iconReset = IconMaker(iconBinReset, tmpFileName + "icon_reset");
	var btnReset = grZoom.add("iconbutton", undefined, iconReset);
	btnReset.preferredSize = [20, 20];
	btnReset.helpTip = "Reset settings";
	btnReset.onClick = function() {
		if (debugMode) $.writeln("Reset");
		Reset();
	}

	var stZoom = grZoom.add("statictext", undefined, "Zoom:");
	var etZoom = grZoom.add("edittext", undefined, set.zoom);
	etZoom.characters = 3;
	etZoom.onChange = function() {
		if (this.text == "") {
			alert("The \"Zoom\" text field should not be empty.", "Error", true);
			this.text = String(set.zoom);
		}
		else if (isNaN(this.text)) {
			alert("\"Zoom\" should be a number.", "Error", true);
			this.text = String(set.zoom);
		}
		else {
			set.zoom = Number(this.text);
		}
	}

	var cbStory = pnlLocation.add("checkbox", undefined, "Selected story");
	cbStory.value = set.cbStory;
	cbStory.alignment = "left";
	cbStory.helpTip = "Process only the selected story";
	cbStory.onClick = function() {
		set.cbStory = this.value;
	}
	
	// Buttons
	var pnlButtons = w.add("panel", undefined, "");
	pnlButtons.orientation = "column";
	pnlButtons.alignment = "fill";
	
	var buttonWidth = 100;
	btnFind = pnlButtons.add("button", undefined, "Find");
	btnFind.preferredSize.width = buttonWidth;
	btnFind.onClick = function() {
		if (app.findGrepPreferences.findWhat == "") {
			alert("Please select your find/change settings and try again.", scriptName, true);
			return;
		}
	
		if (!foundAll) {
			FindAll();
			IterateFinds();
		} 
		else {
			IterateFinds();
		}
	}
		
	btnChange = pnlButtons.add("button", undefined, "Change");
	btnChange.preferredSize.width = buttonWidth;
	btnChange.enabled = false;
	btnChange.onClick = function() {
		ChangeItem();
	}
	
	btnChangeAll = pnlButtons.add("button", undefined, "Change All");
	btnChangeAll.preferredSize.width = buttonWidth;
	btnChangeAll.enabled = false;
	btnChangeAll.onClick = function() {
		app.doScript(ChangeAll, ScriptLanguage.JAVASCRIPT, undefined, UndoModes.ENTIRE_SCRIPT, "\"" + scriptName + "\" Script");
	}
	
	btnChangeFind = pnlButtons.add("button", undefined, "Change/Find");
	btnChangeFind.preferredSize.width = buttonWidth;
	btnChangeFind.enabled = false;	
	btnChangeFind.onClick = function() {
	
		if (app.selection.length == 1 && app.selection[0].hasOwnProperty("baseline")) {
			ProcessText(app.selection[0]);
			IterateFindsChange();
		}
		else {
			alert("Something went wrong: no text was selected.", scriptName, true);
			return;
		}
	} 
	
	var btnClose = pnlButtons.add("button", undefined, "Close");
	btnClose.preferredSize.width = buttonWidth;
	btnClose.onClick = function() { 
		w.close();
	}

	var btnAbout = pnlButtons.add("button", undefined, "About");
	btnAbout.preferredSize.width = buttonWidth;
	btnAbout.onClick = function() {
		JumpToLink(tmpFileName);
	}

	w.show();
}	
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function GetDialogSettings() {
	set = eval(app.extractLabel("Kas_" + scriptName));
	if (set == undefined) {
		set = {dlgLocation: null, zoom: 100, ddlLocation: 0, cbStory: false};
	}

	tmp = set; // for dubugging only

	if (set.dlgLocation != null) {
		set.dlgLocation = set.dlgLocation.split(","); // location is array of numbers
		set.dlgLocation[0] = Number(set.dlgLocation[0]);
		set.dlgLocation[1] = Number(set.dlgLocation[1]);
	}

	set.zoom = Number(set.zoom);

	if (isNaN(set.zoom) || set.zoom == 0) { // if something goes, wrong reset to 100%
		set.zoom = 100;
	}

	return set;
}	
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function PreCheck() {
	if (app.documents.length == 0) ErrorExit("Please open a document and try again.", true);
	doc = app.activeDocument;
	if (doc.converted) ErrorExit("The current document has been modified by being converted from older version of InDesign. Please save the document and try again.", true);
	if (!doc.saved) ErrorExit("The current document has not been saved since it was created. Please save the document and try again.", true);
	tmpFileName = scriptName.replace(/\-\s\d+\.\d+$/, "").replace(/\s+/g, "_").toLowerCase();
	CreateDialog();
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function ErrorExit(error, icon) {
	alert(error, scriptName, icon);
	exit();
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function Reset() {
	doc = hasSpaceAtLineEnd = null;
	f = 0;
	counter = 1;
	textArr = [];
	foundAll = warning = false;
	
	if (typeof btnFind != "undefined") {
		btnFind.text = "Find";
	}

	if (typeof btnChange != "undefined") {
		btnChange.enabled = false;
	}
	
	if (typeof btnChangeAll != "undefined") {
		btnChangeAll.enabled = false;
	}

	if (typeof btnChangeFind != "undefined") {
		btnChangeFind.enabled = false;
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function IconMaker(icon, name) {
	var iconFile = null;
	var tmpFolder = new Folder(Folder.temp.absoluteURI + "/Kasyan");
	tmpFolder.create();
	iconFile = new File(tmpFolder.absoluteURI + "/" + name + ".png");
	
	if (!iconFile.exists) {
		iconFile.encoding = "BINARY";
		iconFile.open( "w" );
		iconFile.write(icon);
		iconFile.close();
	}

	return iconFile;
} 
//--------------------------------------------------------------------------------------------------------------------------------------------------------
function JumpToLink() {
	var tmpFolder = new Folder(Folder.temp.absoluteURI + "/Kasyan");
	tmpFolder.create();
	var linkJumper = File(tmpFolder.absoluteURI + "/" + tmpFileName + "temp.html");
	
	if (!linkJumper.exists) {
		linkJumper.open("w");
		var linkBody = '<html><head><META HTTP-EQUIV=Refresh CONTENT="0; URL=http://kasyan.ho.ua/indesign/text/find_text_in_location/find_text_in_location.html"></head><body> <p></body></html>'
		linkJumper.write(linkBody);
		linkJumper.close();
	}

	linkJumper.execute();
}